# coding=iso-8859-15
#
# (c) Sami Visnen 2008
#
# This is an example script on how to script Newsflash
# using external socket IO.
#

from newsflash import *
import os

# start up newsflash process
# assume here that this script is being run
# from the tools dir. so use a relative path from here
# to get to the application.
if os.name == 'nt':
    binary = '..\\newsflash.exe'
else:
    binary = '../newsflash.sh'

host = Newsflash()
host.startup(binary)
host.isalive()

print 'host is alive!'

# help us see what's going on
host.command_delay(1)

# lets add a new newsserver to begin with
host.sendkey(KEY_SERVER_ADD)
host.sendstr('news.microsoft.com')
host.sendkey(VK_ACTION_ENTER)
host.sendstr('119')
host.sendkey(VK_ACTION_ENTER)
host.sendkey(VK_ACTION_ENTER)
host.sendkey(VK_ACTION_ENTER)
host.sendkey(VK_ACTION_ENTER)

# say yes to 'would you like to download newsgroup list'
host.sendyes()

# open task view and wait for the task to become complete
host.sendkey(KEY_VIEW_TASKS)
sleep(1)

print 'im now going to try to wait untill the task becomes complete...'
while True:
    src = host.getsrc()
    if src.has_string('.*Complete.*news.microsoft.com.*'):
        break
    sleep(1)
    print 'patience...'

print 'got the list of available newsgroups'
print 'next im going to configure a newsgroup...'
host.sendkey(VK_KILL_WINDOW)
host.sendkey(VK_MOVE_END)
host.sendkey(VK_ACTION_SPACE)
host.sendkey(KEY_GROUP_ADD)
host.sendstr('csharp')
host.sendkey(VK_ACTION_ENTER)
host.sendkey(KEY_LIST_SORT_BY_SIZE)
host.sendkey(VK_FOCUS_NEXT)
host.sendkey(VK_ACTION_SPACE)
host.sendkey(VK_FOCUS_NEXT)
host.sendkey(VK_FOCUS_NEXT)
host.sendkey(VK_FOCUS_NEXT)
host.sendkey(VK_ACTION_SPACE)
host.sendkey(KEY_GROUP_CLEAR)
host.sendyes()
print 'the next step is to download the headers for this group'

host.sendkey(VK_ACTION_SPACE)
# would you like to download headers now?
host.sendyes()
# view advanced options?
host.sendno()

# go to tasks and wait for the download to complete
host.sendkey(KEY_VIEW_TASKS)
host.sendkey(KEY_TASK_CLEAR)
print 'im now going to try to wait untill the task becomes complete...'
print 'this might take a while depending on your internet connection'
while True:
    src = host.getsrc()
    if src.has_string('.*Complete.*microsoft.public.dotnet.*'):
        break
    sleep(5)
    print 'patience...'

print 'next im going to open the group and browse a little...'
host.sendkey(VK_KILL_WINDOW)
host.sendkey(VK_ACTION_SPACE)
for i in range(0, 5):
    host.sendkey(VK_MOVE_DOWN)

host.sendkey(VK_KILL_WINDOW)
host.sendkey(VK_KILL_WINDOW)
print "that's it. all done!"

